# Namespace concerto.metamodel@1.0.0

## Overview
- 50 concepts
- 0 enumerations
- 0 assets
- 0 participants
- 0 transactions
- 0 events
- 50 total declarations

## Imports
- concerto@1.0.0.Concept
- concerto@1.0.0.Asset
- concerto@1.0.0.Transaction
- concerto@1.0.0.Participant
- concerto@1.0.0.Event

## Diagram
```mermaid
classDiagram
class `concerto.metamodel@1.0.0.Position` {
<< concept>>
   + `Integer` `line`
   + `Integer` `column`
   + `Integer` `offset`
}

class `concerto.metamodel@1.0.0.Range` {
<< concept>>
   + `Position` `start`
   + `Position` `end`
   + `String` `source`
}

`concerto.metamodel@1.0.0.Range` "1" *-- "1" `concerto.metamodel@1.0.0.Position`
`concerto.metamodel@1.0.0.Range` "1" *-- "1" `concerto.metamodel@1.0.0.Position`
class `concerto.metamodel@1.0.0.TypeIdentifier` {
<< concept>>
   + `String` `name`
   + `String` `namespace`
}

class `concerto.metamodel@1.0.0.DecoratorLiteral` {
<< concept>>
   + `Range` `location`
}

`concerto.metamodel@1.0.0.DecoratorLiteral` "1" *-- "1" `concerto.metamodel@1.0.0.Range`
class `concerto.metamodel@1.0.0.DecoratorString` {
<< concept>>
   + `String` `value`
}

`concerto.metamodel@1.0.0.DecoratorString` --|> `concerto.metamodel@1.0.0.DecoratorLiteral`
class `concerto.metamodel@1.0.0.DecoratorNumber` {
<< concept>>
   + `Double` `value`
}

`concerto.metamodel@1.0.0.DecoratorNumber` --|> `concerto.metamodel@1.0.0.DecoratorLiteral`
class `concerto.metamodel@1.0.0.DecoratorBoolean` {
<< concept>>
   + `Boolean` `value`
}

`concerto.metamodel@1.0.0.DecoratorBoolean` --|> `concerto.metamodel@1.0.0.DecoratorLiteral`
class `concerto.metamodel@1.0.0.DecoratorTypeReference` {
<< concept>>
   + `TypeIdentifier` `type`
   + `Boolean` `isArray`
}

`concerto.metamodel@1.0.0.DecoratorTypeReference` "1" *-- "1" `concerto.metamodel@1.0.0.TypeIdentifier`
`concerto.metamodel@1.0.0.DecoratorTypeReference` --|> `concerto.metamodel@1.0.0.DecoratorLiteral`
class `concerto.metamodel@1.0.0.Decorator` {
<< concept>>
   + `String` `name`
   + `DecoratorLiteral[]` `arguments`
   + `Range` `location`
}

`concerto.metamodel@1.0.0.Decorator` "1" *-- "*" `concerto.metamodel@1.0.0.DecoratorLiteral`
`concerto.metamodel@1.0.0.Decorator` "1" *-- "1" `concerto.metamodel@1.0.0.Range`
class `concerto.metamodel@1.0.0.Identified`
<< concept>> `concerto.metamodel@1.0.0.Identified`

class `concerto.metamodel@1.0.0.IdentifiedBy` {
<< concept>>
   + `String` `name`
}

`concerto.metamodel@1.0.0.IdentifiedBy` --|> `concerto.metamodel@1.0.0.Identified`
class `concerto.metamodel@1.0.0.Declaration` {
<< concept>>
   + `String` `name`
   + `Decorator[]` `decorators`
   + `Range` `location`
}

`concerto.metamodel@1.0.0.Declaration` "1" *-- "*" `concerto.metamodel@1.0.0.Decorator`
`concerto.metamodel@1.0.0.Declaration` "1" *-- "1" `concerto.metamodel@1.0.0.Range`
class `concerto.metamodel@1.0.0.MapDeclaration` {
<< concept>>
   + `MapKeyType` `key`
   + `AggregateValueType` `value`
}

`concerto.metamodel@1.0.0.MapDeclaration` "1" *-- "1" `concerto.metamodel@1.0.0.MapKeyType`
`concerto.metamodel@1.0.0.MapDeclaration` "1" *-- "1" `concerto.metamodel@1.0.0.AggregateValueType`
`concerto.metamodel@1.0.0.MapDeclaration` --|> `concerto.metamodel@1.0.0.Declaration`
class `concerto.metamodel@1.0.0.MapKeyType` {
<< concept>>
   + `TypeIdentifier` `type`
   + `Decorator[]` `decorators`
   + `Range` `location`
}

`concerto.metamodel@1.0.0.MapKeyType` "1" *-- "1" `concerto.metamodel@1.0.0.TypeIdentifier`
`concerto.metamodel@1.0.0.MapKeyType` "1" *-- "*" `concerto.metamodel@1.0.0.Decorator`
`concerto.metamodel@1.0.0.MapKeyType` "1" *-- "1" `concerto.metamodel@1.0.0.Range`
class `concerto.metamodel@1.0.0.AggregateValueType` {
<< concept>>
   + `TypeIdentifier` `type`
   + `Decorator[]` `decorators`
   + `Range` `location`
}

`concerto.metamodel@1.0.0.AggregateValueType` "1" *-- "1" `concerto.metamodel@1.0.0.TypeIdentifier`
`concerto.metamodel@1.0.0.AggregateValueType` "1" *-- "*" `concerto.metamodel@1.0.0.Decorator`
`concerto.metamodel@1.0.0.AggregateValueType` "1" *-- "1" `concerto.metamodel@1.0.0.Range`
class `concerto.metamodel@1.0.0.AggregateRelationshipValueType`
<< concept>> `concerto.metamodel@1.0.0.AggregateRelationshipValueType`

`concerto.metamodel@1.0.0.AggregateRelationshipValueType` --|> `concerto.metamodel@1.0.0.AggregateValueType`
class `concerto.metamodel@1.0.0.EnumDeclaration` {
<< concept>>
   + `EnumProperty[]` `properties`
}

`concerto.metamodel@1.0.0.EnumDeclaration` "1" *-- "*" `concerto.metamodel@1.0.0.EnumProperty`
`concerto.metamodel@1.0.0.EnumDeclaration` --|> `concerto.metamodel@1.0.0.Declaration`
class `concerto.metamodel@1.0.0.EnumProperty` {
<< concept>>
   + `String` `name`
   + `Decorator[]` `decorators`
   + `Range` `location`
}

`concerto.metamodel@1.0.0.EnumProperty` "1" *-- "*" `concerto.metamodel@1.0.0.Decorator`
`concerto.metamodel@1.0.0.EnumProperty` "1" *-- "1" `concerto.metamodel@1.0.0.Range`
class `concerto.metamodel@1.0.0.ConceptDeclaration` {
<< concept>>
   + `Boolean` `isAbstract`
   + `Identified` `identified`
   + `TypeIdentifier` `superType`
   + `Property[]` `properties`
}

`concerto.metamodel@1.0.0.ConceptDeclaration` "1" *-- "1" `concerto.metamodel@1.0.0.Identified`
`concerto.metamodel@1.0.0.ConceptDeclaration` "1" *-- "1" `concerto.metamodel@1.0.0.TypeIdentifier`
`concerto.metamodel@1.0.0.ConceptDeclaration` "1" *-- "*" `concerto.metamodel@1.0.0.Property`
`concerto.metamodel@1.0.0.ConceptDeclaration` --|> `concerto.metamodel@1.0.0.Declaration`
class `concerto.metamodel@1.0.0.AssetDeclaration`
<< concept>> `concerto.metamodel@1.0.0.AssetDeclaration`

`concerto.metamodel@1.0.0.AssetDeclaration` --|> `concerto.metamodel@1.0.0.ConceptDeclaration`
class `concerto.metamodel@1.0.0.ParticipantDeclaration`
<< concept>> `concerto.metamodel@1.0.0.ParticipantDeclaration`

`concerto.metamodel@1.0.0.ParticipantDeclaration` --|> `concerto.metamodel@1.0.0.ConceptDeclaration`
class `concerto.metamodel@1.0.0.TransactionDeclaration`
<< concept>> `concerto.metamodel@1.0.0.TransactionDeclaration`

`concerto.metamodel@1.0.0.TransactionDeclaration` --|> `concerto.metamodel@1.0.0.ConceptDeclaration`
class `concerto.metamodel@1.0.0.EventDeclaration`
<< concept>> `concerto.metamodel@1.0.0.EventDeclaration`

`concerto.metamodel@1.0.0.EventDeclaration` --|> `concerto.metamodel@1.0.0.ConceptDeclaration`
class `concerto.metamodel@1.0.0.Property` {
<< concept>>
   + `String` `name`
   + `Boolean` `isArray`
   + `Boolean` `isOptional`
   + `Decorator[]` `decorators`
   + `Range` `location`
}

`concerto.metamodel@1.0.0.Property` "1" *-- "*" `concerto.metamodel@1.0.0.Decorator`
`concerto.metamodel@1.0.0.Property` "1" *-- "1" `concerto.metamodel@1.0.0.Range`
class `concerto.metamodel@1.0.0.RelationshipProperty` {
<< concept>>
   + `TypeIdentifier` `type`
}

`concerto.metamodel@1.0.0.RelationshipProperty` "1" *-- "1" `concerto.metamodel@1.0.0.TypeIdentifier`
`concerto.metamodel@1.0.0.RelationshipProperty` --|> `concerto.metamodel@1.0.0.Property`
class `concerto.metamodel@1.0.0.ObjectProperty` {
<< concept>>
   + `String` `defaultValue`
   + `TypeIdentifier` `type`
}

`concerto.metamodel@1.0.0.ObjectProperty` "1" *-- "1" `concerto.metamodel@1.0.0.TypeIdentifier`
`concerto.metamodel@1.0.0.ObjectProperty` --|> `concerto.metamodel@1.0.0.Property`
class `concerto.metamodel@1.0.0.BooleanProperty` {
<< concept>>
   + `Boolean` `defaultValue`
}

`concerto.metamodel@1.0.0.BooleanProperty` --|> `concerto.metamodel@1.0.0.Property`
class `concerto.metamodel@1.0.0.DateTimeProperty`
<< concept>> `concerto.metamodel@1.0.0.DateTimeProperty`

`concerto.metamodel@1.0.0.DateTimeProperty` --|> `concerto.metamodel@1.0.0.Property`
class `concerto.metamodel@1.0.0.StringProperty` {
<< concept>>
   + `String` `defaultValue`
   + `StringRegexValidator` `validator`
   + `StringLengthValidator` `lengthValidator`
}

`concerto.metamodel@1.0.0.StringProperty` "1" *-- "1" `concerto.metamodel@1.0.0.StringRegexValidator`
`concerto.metamodel@1.0.0.StringProperty` "1" *-- "1" `concerto.metamodel@1.0.0.StringLengthValidator`
`concerto.metamodel@1.0.0.StringProperty` --|> `concerto.metamodel@1.0.0.Property`
class `concerto.metamodel@1.0.0.StringRegexValidator` {
<< concept>>
   + `String` `pattern`
   + `String` `flags`
}

class `concerto.metamodel@1.0.0.StringLengthValidator` {
<< concept>>
   + `Integer` `minLength`
   + `Integer` `maxLength`
}

class `concerto.metamodel@1.0.0.DoubleProperty` {
<< concept>>
   + `Double` `defaultValue`
   + `DoubleDomainValidator` `validator`
}

`concerto.metamodel@1.0.0.DoubleProperty` "1" *-- "1" `concerto.metamodel@1.0.0.DoubleDomainValidator`
`concerto.metamodel@1.0.0.DoubleProperty` --|> `concerto.metamodel@1.0.0.Property`
class `concerto.metamodel@1.0.0.DoubleDomainValidator` {
<< concept>>
   + `Double` `lower`
   + `Double` `upper`
}

class `concerto.metamodel@1.0.0.IntegerProperty` {
<< concept>>
   + `Integer` `defaultValue`
   + `IntegerDomainValidator` `validator`
}

`concerto.metamodel@1.0.0.IntegerProperty` "1" *-- "1" `concerto.metamodel@1.0.0.IntegerDomainValidator`
`concerto.metamodel@1.0.0.IntegerProperty` --|> `concerto.metamodel@1.0.0.Property`
class `concerto.metamodel@1.0.0.IntegerDomainValidator` {
<< concept>>
   + `Integer` `lower`
   + `Integer` `upper`
}

class `concerto.metamodel@1.0.0.LongProperty` {
<< concept>>
   + `Long` `defaultValue`
   + `LongDomainValidator` `validator`
}

`concerto.metamodel@1.0.0.LongProperty` "1" *-- "1" `concerto.metamodel@1.0.0.LongDomainValidator`
`concerto.metamodel@1.0.0.LongProperty` --|> `concerto.metamodel@1.0.0.Property`
class `concerto.metamodel@1.0.0.LongDomainValidator` {
<< concept>>
   + `Long` `lower`
   + `Long` `upper`
}

class `concerto.metamodel@1.0.0.Import` {
<< concept>>
   + `String` `namespace`
   + `String` `uri`
}

class `concerto.metamodel@1.0.0.ImportAll`
<< concept>> `concerto.metamodel@1.0.0.ImportAll`

`concerto.metamodel@1.0.0.ImportAll` --|> `concerto.metamodel@1.0.0.Import`
class `concerto.metamodel@1.0.0.ImportType` {
<< concept>>
   + `String` `name`
}

`concerto.metamodel@1.0.0.ImportType` --|> `concerto.metamodel@1.0.0.Import`
class `concerto.metamodel@1.0.0.ImportTypes` {
<< concept>>
   + `String[]` `types`
}

`concerto.metamodel@1.0.0.ImportTypes` --|> `concerto.metamodel@1.0.0.Import`
class `concerto.metamodel@1.0.0.Model` {
<< concept>>
   + `String` `namespace`
   + `String` `sourceUri`
   + `String` `concertoVersion`
   + `Import[]` `imports`
   + `Declaration[]` `declarations`
   + `Decorator[]` `decorators`
}

`concerto.metamodel@1.0.0.Model` "1" *-- "*" `concerto.metamodel@1.0.0.Import`
`concerto.metamodel@1.0.0.Model` "1" *-- "*" `concerto.metamodel@1.0.0.Declaration`
`concerto.metamodel@1.0.0.Model` "1" *-- "*" `concerto.metamodel@1.0.0.Decorator`
class `concerto.metamodel@1.0.0.Models` {
<< concept>>
   + `Model[]` `models`
}

`concerto.metamodel@1.0.0.Models` "1" *-- "*" `concerto.metamodel@1.0.0.Model`
class `concerto.metamodel@1.0.0.ScalarDeclaration`
<< concept>> `concerto.metamodel@1.0.0.ScalarDeclaration`

`concerto.metamodel@1.0.0.ScalarDeclaration` --|> `concerto.metamodel@1.0.0.Declaration`
class `concerto.metamodel@1.0.0.BooleanScalar` {
<< concept>>
   + `Boolean` `defaultValue`
}

`concerto.metamodel@1.0.0.BooleanScalar` --|> `concerto.metamodel@1.0.0.ScalarDeclaration`
class `concerto.metamodel@1.0.0.IntegerScalar` {
<< concept>>
   + `Integer` `defaultValue`
   + `IntegerDomainValidator` `validator`
}

`concerto.metamodel@1.0.0.IntegerScalar` "1" *-- "1" `concerto.metamodel@1.0.0.IntegerDomainValidator`
`concerto.metamodel@1.0.0.IntegerScalar` --|> `concerto.metamodel@1.0.0.ScalarDeclaration`
class `concerto.metamodel@1.0.0.LongScalar` {
<< concept>>
   + `Long` `defaultValue`
   + `LongDomainValidator` `validator`
}

`concerto.metamodel@1.0.0.LongScalar` "1" *-- "1" `concerto.metamodel@1.0.0.LongDomainValidator`
`concerto.metamodel@1.0.0.LongScalar` --|> `concerto.metamodel@1.0.0.ScalarDeclaration`
class `concerto.metamodel@1.0.0.DoubleScalar` {
<< concept>>
   + `Double` `defaultValue`
   + `DoubleDomainValidator` `validator`
}

`concerto.metamodel@1.0.0.DoubleScalar` "1" *-- "1" `concerto.metamodel@1.0.0.DoubleDomainValidator`
`concerto.metamodel@1.0.0.DoubleScalar` --|> `concerto.metamodel@1.0.0.ScalarDeclaration`
class `concerto.metamodel@1.0.0.StringScalar` {
<< concept>>
   + `String` `defaultValue`
   + `StringRegexValidator` `validator`
   + `StringLengthValidator` `lengthValidator`
}

`concerto.metamodel@1.0.0.StringScalar` "1" *-- "1" `concerto.metamodel@1.0.0.StringRegexValidator`
`concerto.metamodel@1.0.0.StringScalar` "1" *-- "1" `concerto.metamodel@1.0.0.StringLengthValidator`
`concerto.metamodel@1.0.0.StringScalar` --|> `concerto.metamodel@1.0.0.ScalarDeclaration`
class `concerto.metamodel@1.0.0.DateTimeScalar` {
<< concept>>
   + `String` `defaultValue`
}

`concerto.metamodel@1.0.0.DateTimeScalar` --|> `concerto.metamodel@1.0.0.ScalarDeclaration`
```

